CREATE TABLE voters (
    public_token character varying(250) NOT NULL PRIMARY KEY,
    fullname character varying(250) NOT NULL,
    email character varying(250)
);

CREATE TABLE questions (
    name character varying(250) NOT NULL PRIMARY KEY,
    position integer NOT NULL,
    title character varying(250) NOT NULL,
    sentence text NOT NULL,
    min_choices integer NOT NULL DEFAULT 0,
    max_choices integer DEFAULT NULL,
    vote_open boolean NOT NULL DEFAULT FALSE
    CONSTRAINT nb_choices_range_valid CHECK (max_choices IS NULL OR min_choices <= max_choices)
);

CREATE TABLE answers (
    question_name character varying(250) NOT NULL REFERENCES questions(name) ON DELETE CASCADE ON UPDATE CASCADE,
    name character varying(250) NOT NULL,
    position integer NOT NULL,
    sentence text NOT NULL,
    vote_count integer NOT NULL DEFAULT 0,
    UNIQUE(question_name, name)
);

CREATE TABLE votes (
    voter_token character varying(250) NOT NULL UNIQUE REFERENCES voters(public_token) ON DELETE CASCADE ON UPDATE CASCADE,
    vote_time timestamp NOT NULL DEFAULT NOW()
);



INSERT INTO questions VALUES('moral',     1, 'rapport moral',              'D accord rapport moral ?',     1, 1);
INSERT INTO questions VALUES('financier', 2, 'rapport financier',          'D accord rapport financier ?', 1, 1);
INSERT INTO questions VALUES('ca',        3, 'constitution du nouveau CA', 'Qui qui ya dans le CA ?',      0, NULL);

INSERT INTO answers VALUES('moral',     'oui',   1, 'Oui !');
INSERT INTO answers VALUES('moral',     'non',   2, 'Non');
INSERT INTO answers VALUES('moral',     'blanc', 3, 'Blanc');

INSERT INTO answers VALUES('financier', 'oui',   1, 'Oui !');
INSERT INTO answers VALUES('financier', 'non',   2, 'Non');
INSERT INTO answers VALUES('financier', 'blanc', 3, 'Blanc');

INSERT INTO answers VALUES('ca',        'a',     1, 'Alice');
INSERT INTO answers VALUES('ca',        'b',     2, 'Bob');
INSERT INTO answers VALUES('ca',        'c',     3, 'Charline');
INSERT INTO answers VALUES('ca',        'd',     4, 'Dédé');

INSERT INTO voters VALUES('953d2c15c76c7d2ef4867669d406c713a5e20663d57d6aa20b8ae8fd48dda309', 'Robert Hacker', 'robert@example.org');
INSERT INTO voters VALUES('7717e6ba488ff754fea8b57b22048c6dc6115f2c37b9fc8e87321da76045cbfb', 'Dédé', 'dd@example.org');
